# -*- coding: utf-8 -*-
#
# Copyright 2012 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

"""Miscelaneous functions and constants for darwin."""

import os
import shutil
import sys

from twisted.internet import defer

from dirspec.basedir import save_config_path
from ubuntuone.controlpanel.logger import setup_logging

logger = setup_logging('utils.darwin')
AUTOUPDATE_BIN_NAME = 'autoupdate-darwin'
UNINSTALL_BIN_NAME = 'uninstall-darwin'


def add_to_autostart():
    """Add syncdaemon to the session's autostart."""
    # TODO


@defer.inlineCallbacks
def are_updates_present():
    """Return if there are updates for Ubuntu One."""
    result = False
    # TODO
    defer.returnValue(result)


def default_folders(user_home=None):
    """Return a list of the folders to add by default."""
    folders = []
    # TODO
    return folders


def install_config_and_daemons():
    """Install required data files and fsevents daemon.

    This function is a replacement for an installer. As such it is
    required on first-run, but it's also called every time we start
    up, in case anything has moved or been deleted.
    """

    # Do nothing if we are running from source:
    if getattr(sys, 'frozen', None) is None:
        return

    main_app_dir = ''.join(__file__.partition('.app')[:-1])
    main_app_resources_dir = os.path.join(main_app_dir,
                                          'Contents',
                                          'Resources')

    config_path = save_config_path('ubuntuone')

    conf_filenames = ['syncdaemon.conf',
                      'logging.conf']
    for conf_filename in conf_filenames:
        src_path = os.path.join(main_app_resources_dir,
                                conf_filename)
        dest_path = os.path.join(config_path,
                                 conf_filename)

        if not os.path.exists(dest_path):
            shutil.copyfile(src_path, dest_path)


def perform_update():
    """Spawn the autoupdate process and call the stop function."""
    # TODO


def uninstall_application():
    """Uninstall Ubuntu One."""
    # TODO
